commit 08db1b36051409e79cc8069867f02d1d6e739eb9
Author: freddy77 <freddy77>
Date:   Thu Oct 23 12:39:38 2008 +0000

    support conversions from SQL_C_WCHAR to fixed types

diff --git a/ChangeLog b/ChangeLog
index 6fa97c7..e86d021 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Thu Oct 23 14:38:40 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/convert_tds2sql.c:
+	- support conversions from SQL_C_WCHAR to fixed types
+
 Thu Oct 23 14:32:15 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/convert_tds2sql.c: 
 	- reduce some variable scope
@@ -753,4 +757,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2634 2008/10/23 12:33:59 freddy77 Exp $
+$Id: ChangeLog,v 1.2635 2008/10/23 12:39:38 freddy77 Exp $
diff --git a/src/odbc/convert_tds2sql.c b/src/odbc/convert_tds2sql.c
index 23c5734..9df2f02 100644
--- a/src/odbc/convert_tds2sql.c
+++ b/src/odbc/convert_tds2sql.c
@@ -32,6 +32,8 @@
 #include <string.h>
 #endif /* HAVE_STRING_H */
 
+#include <ctype.h>
+
 #include "tdsodbc.h"
 #include "tdsconvert.h"
 #include "tdsiconv.h"
@@ -40,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.59 2008/10/23 12:33:59 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.60 2008/10/23 12:39:38 freddy77 Exp $");
 
 #if SIZEOF_SQLWCHAR == 2
 # if WORDS_BIGENDIAN
@@ -58,6 +60,8 @@ TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.59 2008/10/23 12:33:59 freddy77 Exp $
 #error SIZEOF_SQLWCHAR not supported !!
 #endif
 
+#define TDS_ISSPACE(c) isspace((unsigned char) (c))
+
 static SQLLEN
 odbc_convert_char(TDS_STMT * stmt, TDSCOLUMN * curcol, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen)
 {
@@ -102,6 +106,41 @@ odbc_convert_char(TDS_STMT * stmt, TDSCOLUMN * curcol, TDS_CHAR * src, TDS_UINT
 	return ol;
 }
 
+static int
+odbc_tds_convert_wide_iso(TDSCOLUMN *curcol, TDS_CHAR *src, TDS_UINT srclen, TDS_CHAR *buf, TDS_UINT buf_len)
+{
+	TDS_CHAR *p;
+	/* TODO check for endian */
+	
+	/* skip white spaces */
+	while (srclen > 1 && src[1] == 0 && TDS_ISSPACE(src[0])) {
+		srclen -= 2;
+		src += 2;
+	}
+
+	/* convert */
+	p = buf;
+	while (buf_len > 1 && srclen > 1 && src[1] == 0) {
+		*p++ = src[0];
+		--buf_len;
+		srclen -= 2;
+		src += 2;
+	}
+
+	/* skip white spaces */
+	while (srclen > 1 && src[1] == 0 && TDS_ISSPACE(src[0])) {
+		srclen -= 2;
+		src += 2;
+	}
+
+	/* still characters, wrong format */
+	if (srclen)
+		return -1;
+
+	*p = 0;
+	return p - buf;
+}
+
 SQLLEN
 odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen,
 	     const struct _drecord *drec_ixd)
@@ -115,6 +154,7 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 	SQLLEN ret = SQL_NULL_DATA;
 	int i, cplen;
 	int binary_conversion = 0;
+	TDS_CHAR conv_buf[256];
 
 	tdsdump_log(TDS_DBG_FUNC, "odbc_tds2sql: src is %d dest = %d\n", srctype, desttype);
 
@@ -172,9 +212,15 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 			return odbc_convert_char(stmt, curcol, src, srclen, desttype, dest, destlen);
 		if (is_unicode_type(srctype)) {
 			/*
-			 * TODO convert to single and then process normally.
+			 * convert to single and then process normally.
 			 * Here we processed SQL_C_BINARY and SQL_C_*CHAR so only fixed types are left
 			 */
+			i = odbc_tds_convert_wide_iso(curcol, src, srclen, conv_buf, sizeof(conv_buf));
+			if (i < 0)
+				return SQL_NULL_DATA;
+			src = conv_buf;
+			srclen = i;
+			srctype = SYBVARCHAR;
 		}
 	}
 

